#ifndef _GEOMETRIE_H
    #define _GEOMETRIE_H

#include <gx.h>
#include <math.h>

#define RADtoDEG 57.29577319
#define DEGtoRAD 0.318309851

GXvector Vector(GXpoint A, GXpoint B);
GXvector Vector_XY(double x, double y);
double ProdScal(GXvector A, GXvector B);
double ProdVect(GXvector U, GXvector V);
double SqrNorm(GXvector U);
double SqrDist(GXvector A, GXvector B);
double AngleRadian(GXpoint A, GXpoint B, GXpoint C); 
bool InterSegment(GXpoint A, GXpoint B, GXpoint C, GXpoint D, GXpoint *P);
double ProjPntDte(GXpoint A, GXpoint B, GXpoint C, GXpoint *P);
int OrientationT(GXpoint A, GXpoint B, GXpoint C);

#endif
