#include "../include/serpent.h"

extern Segment * segments;
extern Cercle * cercles;
extern Serpent * serpents;
uchar gris[3], rouge[3], vert[3], bleu[3], decor_c[3], impact_c[3];

void dessine_cercles(void)
{
    Cercle *tmp = cercles;

    while ( tmp != NULL ) {
	gx_Circlef(tmp->C.x, tmp->C.y, tmp->rayon, gris, 2);
	tmp = tmp->suiv;
    }
}

void dessine_segments(void)
{
    Segment * tmp = segments;

    while ( tmp != NULL ) {
	gx_Linef(tmp->A.x, tmp->A.y, tmp->B.x, tmp->B.y, gris, 2);
	tmp = tmp->suiv;
    }
}

void dessine_particules(Particule *p)
{
    while ( p != NULL ) {
#ifdef _VITESSE // Pour voir le vecteur vitesse de p ( agrandi )
	gx_Linef(p->position.x, p->position.y, p->position.x+8*p->vitesse.x,
		 p->position.y+8*p->vitesse.y, rouge, 2);
#endif
	gx_Spotf(p->position.x, p->position.y, p->rayon, p->col);
	p = p->suiv;
    }
}

void dessine_serpents(void)
{
    Serpent * tmp = serpents;

    while ( tmp != NULL ) {
	dessine_particules(tmp->tete);
#ifdef _PILOTE // Pour voir le pilote
#ifdef _VITESSE // Pour voir le vecteur vitesse
	gx_Linef(tmp->pilote->position.x, tmp->pilote->position.y, 
		tmp->pilote->position.x+tmp->pilote->vitesse.x,
		tmp->pilote->position.y+tmp->pilote->vitesse.y, bleu, 2);
#endif
	gx_Spotf(tmp->pilote->position.x, tmp->pilote->position.y, 
		tmp->pilote->rayon, impact_c);
#endif
	tmp = tmp->suiv;
    }
}

void decor(void)
{
    // bas
    gx_FillQuadf_4col(0.0,0.0,decor_c,100.,0.0,decor_c,95.,5.,gris,5.,5.,gris);
    // gauche
    gx_FillQuadf_4col(0.0,0.0,decor_c,5.,5.,gris,5.,95.,gris,0.0,100.,decor_c);
    // haut
    gx_FillQuadf_4col(0.0,100.,decor_c,5.,95.,gris,95.,95.,gris,100.,100.,decor_c);
    // droite
    gx_FillQuadf_4col(100.,100.,decor_c,100.,.0,decor_c,95.,5.,gris,95.,95.,gris);
}

void impact(GXpoint I)
{
    gx_Spotf(I.x,I.y,04.,impact_c);
}
