/*
 * Projet L2.1 Algorithmique Graphique
 * "Chasse au serpent"
 * Daniel Borges
 */

#include "../include/serpent.h"

Segment * segments;
Cercle * cercles;
Serpent * serpents;
Serpent * cible;
extern uchar gris[3], rouge[3], vert[3], bleu[3], decor_c[3], impact_c[3];

void Init(void)
{
    cercles = NULL;
    segments = NULL;
    serpents = NULL;
    cible = NULL;

    // AlgoGraphX
    gx_InitWindow("Chasse au serpent");
    gx_SetWindowCoord(0.0,0.0,100.0,100.0);

    // Couleurs
    gris[0] = gris[1] = gris[2] = 128;
    rouge[0] = vert[1] = bleu[2] = 255;
    rouge[1] = rouge[2] = vert[0] = vert[2] = bleu[0] = bleu[1] = 0;
    decor_c[0] = decor_c[1] = decor_c[2] = 32;
    impact_c[0] = impact_c[2] = impact_c[1] = 128;

    // Contour
    ajouter_segment(05.,05.,95.,05.); // bas
    ajouter_segment(95.,05.,95.,95.); // droite
    ajouter_segment(95.,95.,05.,95.); // haut
    ajouter_segment(05.,95.,05.,05.); // gauche
    ajouter_segment(95.,85.,85.,95.); // haut-droite
    ajouter_segment(05.,15.,15.,05.); // gauche-bas
    ajouter_segment(75.,05.,95.,15.); // bas-droite

    // Cercles
    ajouter_cercle(00.,100.,20.);  // en haut  gauche
    ajouter_cercle(50.,50.,10.);   // au centre
    ajouter_cercle(52.,22.5,07.);  // en dessous du central
    ajouter_cercle(77.5,40.,05.);  //  droite 
    ajouter_cercle(35.,15.,02.);   //  gauche de celui du bas

    // Carr
    ajouter_segment(55.,72.5,45.,72.5); // bas
    ajouter_segment(45.,72.5,45.,82.5); // gauche
    ajouter_segment(45.,82.5,55.,82.5); // haut
    ajouter_segment(55.,82.5,55.,72.5); // droite

    // Losange
    ajouter_segment(17.5,50.,22.5,60.); // haut-gauche
    ajouter_segment(22.5,60.,27.5,50.); // haut-droite
    ajouter_segment(27.5,50.,22.5,40.); // bas-droite
    ajouter_segment(22.5,40.,17.5,50.); // bas-gauche

    // Cible
    ajouter_serpent(gx_Point(15.,18.),gx_Vector_XY(0.4,0.4),0.2,50,NULL);
    cible = serpents;
    // Chasseurs
    ajouter_serpent(gx_Point(23.,87.),gx_Vector_XY(0.5,0.0),1.,1,rouge);
    ajouter_serpent(gx_Point(85.,85.),gx_Vector_XY(-0.3,-0.3),1.,1,rouge);
    ajouter_serpent(gx_Point(27.,33.),gx_Vector_XY(-0.4,-0.2),1.,1,rouge);
    ajouter_serpent(gx_Point(87.,73.),gx_Vector_XY(-0.4,-0.2),1.,1,rouge);
    ajouter_serpent(gx_Point(18.,24.),gx_Vector_XY(0.5,-0.8),1.,1,rouge);
    ajouter_serpent(gx_Point(25.,23.),gx_Vector_XY(-0.4,-0.3),1.,1,rouge);
    ajouter_serpent(gx_Point(81.,83.),gx_Vector_XY(-0.4,-0.2),1.,1,rouge);
}

void Clean(void)
{
    liberer_cercles();
    liberer_segments();
    liberer_serpents();
}

void Dessin(void)
{
    if ( ! gx_Running() )
	return;

    gx_Clean();

    // Affichage
    dessine_cercles();
    dessine_segments();
    decor();
    dessine_serpents();

    // Actions
    mouvements();
    rencontres();

    gx_Show();
}

int main (void)
{
    Init();

    gx_SetAnimationFunction(Dessin);
    gx_SetFreeFunction(Clean);
    gx_MainStart();

    return 0;
}
